#include <Adafruit_GFX.h>
#include <Adafruit_ILI9341.h>

#define TFT_CS 5       // Chip select control pin
#define TFT_DC 16      // Data/command control pin
#define TFT_RST 4      // Reset pin
#define TFT_MOSI 13    // SPI MOSI
#define TFT_SCLK 18    // SPI Clock
#define TFT_MISO 19    // SPI MISO (opcional)
#define TFT_BACKLIGHT 2 // Backlight control pin (LED)

Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC, TFT_RST);

void setup() {
  Serial.begin(115200);
  Serial.println("Inicializando ILI9341...");

  // Configurar o pino do backlight
  pinMode(TFT_BACKLIGHT, OUTPUT);
  digitalWrite(TFT_BACKLIGHT, HIGH); // Acender o backlight

  // Reset manual do display
  pinMode(TFT_RST, OUTPUT);
  digitalWrite(TFT_RST, LOW);
  delay(100);
  digitalWrite(TFT_RST, HIGH);
  delay(100);

  // Inicializar o display com frequência reduzida
  tft.begin(4000000);
  tft.setRotation(1); // Ajustar conforme necessário (1, 2, 3 ou 4)

  // Limpar a tela e imprimir algo simples
  tft.fillScreen(ILI9341_BLACK);
  tft.setTextColor(ILI9341_WHITE);
  tft.setTextSize(2);
  tft.setCursor(10, 10);
  tft.println("Teste Adafruit ILI9341");
  Serial.println("Inicialização concluída!");
}

void loop() {
  // Teste de mudança de cor para depuração
  tft.fillScreen(ILI9341_RED);
  delay(1000);
  tft.fillScreen(ILI9341_GREEN);
  delay(1000);
  tft.fillScreen(ILI9341_BLUE);
  delay(1000);
}
